unit InspUnit;

interface
            
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, InspCtrl, CompInsp,PropList, ExtCtrls,cad,TypInfo, ComCtrls,
  Buttons;

type
  TInspFrm = class(TForm)
    Panel2: TPanel;
    ComponentComboBox1: TComponentComboBox;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    ComponentInspector1: TComponentInspector;
   procedure ComponentInspector1SetValue(Sender: TObject; TheIndex: Integer; var Value: String; var EnableDefault: Boolean);
    function ComponentInspector1CallEditor(Sender: TObject;
      TheIndex: Integer; var EnableDefault: Boolean): Boolean;
    procedure ComponentInspector1GetButtonType(Sender: TObject;
      TheIndex: Integer; var Value: TButtonType);
    procedure ComponentInspector1GetEnableExternalEditor(Sender: TObject;
      TheIndex: Integer; var Value: Boolean);
    procedure FormActivate(Sender: TObject);
    procedure ComponentInspector1GetName(Sender: TObject;
      TheIndex: Integer; var Value: String);
   procedure ComponentInspector1GetValue(Sender: TObject;
     TheIndex: Integer; var Value: String);
    procedure ComponentComboBox1GetComponentText(Sender: TObject;
      AComponent: TComponent; var Text: String);
    procedure ComponentComboBox1Change(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ComponentComboBox1Filter(Sender: TObject;
      AComponent: TComponent; var EnableAdd: Boolean);
    procedure PageControl1Change(Sender: TObject);
    procedure ComponentInspector1Filter(Sender: TObject; Prop: TProperty;
      var Result: Boolean);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  InspFrm: TInspFrm;

implementation

{$R *.dfm}
uses MainUnit;


procedure TInspFrm.ComponentInspector1SetValue(Sender: TObject;
  TheIndex: Integer; var Value: String; var EnableDefault: Boolean);
begin

IF ComponentInspector1.Instance <> nil THEN
if Assigned(ComponentInspector1.Properties[TheIndex]) THEN
    IF ComponentInspector1.Properties[TheIndex].Name='Angle' THEN
     Value:= FloatToStr(StrToInt(Value)*pi/180);

 Mainfrm.MyCAD1.Invalidate
end;


function TInspFrm.ComponentInspector1CallEditor(Sender: TObject;   TheIndex: Integer; var EnableDefault: Boolean): Boolean;
var
  OldValue: string;
begin
 Result:=False;
  with ComponentInspector1 do
  begin
    if Assigned(Properties[TheIndex]) then
      with Properties[TheIndex] do
        if TypeKind in [tkString,tkWString,tkLString] then
        begin
          EnableDefault:=False;
          OldValue:=AsString;
          AsString:=InputBox(ComponentInspector1.Instance.Name,Name,OldValue);
          Result:=AsString<>OldValue;
          if Result then Mainfrm.MyCAD1.Invalidate
        end;


  end;

end;

procedure TInspFrm.ComponentInspector1GetButtonType(Sender: TObject;
  TheIndex: Integer; var Value: TButtonType);
begin

  with ComponentInspector1 do
    if Assigned(Properties[TheIndex]) then
      with Properties[TheIndex] do
      if   (TypeKind in [tkString,tkWString,tkLString])and (Value=btNone) then
        Value:=btDialog;

end;

procedure TInspFrm.ComponentInspector1GetEnableExternalEditor(
  Sender: TObject; TheIndex: Integer; var Value: Boolean);
begin
 with ComponentInspector1 do
    if Assigned(Properties[TheIndex]) then
    begin
      with Properties[TheIndex] do

        Value:=(TypeKind in [tkString,tkWString,tkLString]) or
        (PropType=TypeInfo(TColor) )  or IsType(TypeInfo(TGraphic))
        or IsType(TypeInfo(TUserData)) or IsType(TypeInfo(TStrings));

    end;

end;

procedure TInspFrm.FormActivate(Sender: TObject);
begin
   MainFrm.setInspector;
end;

procedure TInspFrm.ComponentInspector1GetName(Sender: TObject;
  TheIndex: Integer; var Value: String);
begin
//[sample]replace the property name in Inspector
//Like:
//if ComponentInspector1.Properties[TheIndex].Name='Name' then
//  value:='Property_Name';
end;

procedure TInspFrm.ComponentInspector1GetValue(Sender: TObject;
  TheIndex: Integer; var Value: String);
begin

IF ComponentInspector1.Instance <> nil THEN
   if Assigned(ComponentInspector1.Properties[TheIndex]) THEN
   BEGIN
       IF ComponentInspector1.Properties[TheIndex].Name='Angle' THEN
       try
          IF Value='' THEN Value:='0';
           Value:= IntToStr(Round(StrToFloat(Value)*180/pi));
       Except
         Value:='0';
       end;

       IF   ComponentInspector1.Properties[TheIndex].Name='UserData' THEN
          IF (ComponentInspector1.Properties[TheIndex].AsObject as TUserData).getcount =0 then
           Value:='(Empty)'
           else
            Value:='(Text)';
    END;

end;

procedure TInspFrm.ComponentComboBox1GetComponentText(Sender: TObject;
  AComponent: TComponent; var Text: String);
begin
//To Change the display text in ComponentCombobox
//like:
//if Text = 'Shape0: TMyRectangle' THEN Text:='Rectangle';
end;

procedure TInspFrm.ComponentComboBox1Change(Sender: TObject);
begin

With   ComponentComboBox1 do
if (Items.Objects[ItemIndex] is TMyShape) and  ((Items.Objects[ItemIndex] as TMyShape).ParentShapeNo=-1 ) then
begin
   // when only parent shape   select then to do this code:
   MainFrm.MyCAD1.SelectShapeByCode(TMyShape(Items.Objects[ItemIndex]).GetShapeId);

end;
 //  ComponentInspector1.Instance:= ComponentComboBox1.Items.Objects[ItemIndex] as TComponent;
end;

procedure TInspFrm.FormShow(Sender: TObject);
begin

 MainFrm.setInspector;
end;

procedure TInspFrm.ComponentComboBox1Filter(Sender: TObject;
  AComponent: TComponent; var EnableAdd: Boolean);
begin

   EnableAdd:=false;
   IF AComponent IS TMyCAD THEN
   BEGIN
   EnableAdd:=true;

   END;
   IF AComponent IS TMyShape THEN

   If MainFrm.MonitorParentShapesOnly THEN
    BEGIN
        If (NOT ((AComponent As  TMyShape).HasParentShape)) THEN  EnableAdd :=true;
    END
    ELSE // childshape only , add the brother shapes
    BEGIN
        If  MainFrm.MyCAD1.areTheyBrother ((AComponent As  TMyShape),MainFrm.ASelectedChildShape) THEN
        begin
         EnableAdd :=true;
         end;
    END

end;

procedure TInspFrm.PageControl1Change(Sender: TObject);
begin
  with ComponentInspector1 do
  begin
    Lock;
    try
      Mode:=TCompInspMode(PageControl1.TabIndex);
    finally
      Unlock;
    end;
  end;
end;


procedure TInspFrm.ComponentInspector1Filter(Sender: TObject;
  Prop: TProperty; var Result: Boolean);
begin
//
end;

end.
